Loading...
Searching...
No Matches
Sip_status

## Data Structures

struct | sip_status_s
| Structure for SIP status line. More...

## Macros

#define | sip_status(sip)
| Access a SIP status line structure sip_status_t from sip_t.
#define | SIP_STATUS_INIT()
| Initializer for structure sip_status_t.
#define | SIPTAG_STATUS(x)
| Tag list item for pointer to a status line structure sip_status_t.
#define | SIPTAG_STATUS_REF(x)
| Tag list item for reference to a status line pointer.
#define | SIPTAG_STATUS_STR(s)
| Tag list item for string with status line value.
#define | SIPTAG_STATUS_STR_REF(x)
| Tag list item for reference to a status line string.

## Typedefs

typedef struct sip_status_s | sip_status_t
| @

## Functions

issize_t | sip_status_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP status line.
issize_t | sip_status_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP status line.
sip_status_t * | sip_status_init (sip_status_t x[1])
| Initialize a structure sip_status_t.
int | sip_is_status (sip_header_t const *header)
| Test if header object is instance of sip_status_t.
sip_status_t * | sip_status_dup (su_home_t *home, sip_status_t const *hdr))
| Duplicate a list of status line header structures sip_status_t.
sip_status_t * | sip_status_copy (su_home_t *home, sip_status_t const *hdr))
| Copy a list of status line header structures sip_status_t.
sip_status_t * | sip_status_make (su_home_t *home, char const *s))
| Make a status line structure sip_status_t.
sip_status_t * | sip_status_format (su_home_t *home, char const *fmt,...)))
| Make a status line from formatting result.
sip_status_t * | sip_status_create (su_home_t *home, unsigned status, char const *phrase, char const *version)
| Create a status line object.

## Variables

msg_hclass_t | sip_status_class []
| Header class for status line.
tag_typedef_t | siptag_status
| Tag for status line object.
tag_typedef_t | siptag_status_str
| Tag for string with status line value.

## Detailed Description

## Macro Definition Documentation

## SIP_STATUS_INIT

#define SIP_STATUS_INIT | ( |  | ) |

Initializer for structure sip_status_t.

A static sip_status_t structure for status line must be initialized with the SIP_STATUS_INIT() macro. For instance,

sip_status_t sip_status = SIP_STATUS_INIT;
sip_status
#define sip_status(sip)
Access a SIP status line structure sip_status_t from sip_t.
Definition sip_protos.h:369
sip_status_t
struct sip_status_s sip_status_t
@
Definition sip.h:133
SIP_STATUS_INIT
#define SIP_STATUS_INIT()
Initializer for structure sip_status_t.
Definition sip_protos.h:386

## SIPTAG_STATUS

#define SIPTAG_STATUS | ( |  | x | ) |

Tag list item for pointer to a status line structure sip_status_t.

The SIPTAG_STATUS() macro is used to include a tag item with a pointer to a sip_status_t structure in a tag list.

Parameters

  x | pointer to a sip_status_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_STATUS_REF().

## SIPTAG_STATUS_STR

#define SIPTAG_STATUS_STR | ( |  | s | ) |

Tag list item for string with status line value.

The SIPTAG_STATUS_STR() macro is used to include a tag item with a string containing value of a sip_status_t header in a tag list.

Parameters

  s | pointer to a string containing status line value, or NULL.

The string in SIPTAG_STATUS_STR() can be converted to a sip_status_t header structure by giving the string s has second argument to function sip_status_make().

The corresponding tag taking reference parameter is SIPTAG_STATUS_STR_REF().

## Typedef Documentation

## sip_status_t

typedef struct sip_status_s sip_status_t

@

The status line is first line in a response message. It is defined in RFC 3261 as follows:

Status-Line = SIP-Version SP Status-Code SP Reason-Phrase CRLF
Status-Code = Informational
/ Redirection
/ Success
/ Client-Error
/ Server-Error
/ Global-Failure
/ extension-code
extension-code = 3DIGIT
Reason-Phrase = *(reserved / unreserved / escaped
/ UTF8-NONASCII / UTF8-CONT / SP / HTAB)
CRLF
#define CRLF
DIGIT
#define DIGIT
SP
#define SP

The parsed status line is stored in sip_status_t structure.

The structure sip_status_t contains representation of SIP status line.

The sip_status_t is defined as follows:

typedef struct sip_status_s {
sip_common_t st_common[1]; // Common fragment info
sip_unknown_t *st_next; // Link to next (dummy)
char const *st_version; // Protocol version
int st_status; // Status code
char const *st_phrase; // Status phrase
} sip_status_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_status_s
Structure for SIP status line.
Definition sip.h:370
sip_status_s::st_phrase
char const * st_phrase
Status phrase.
Definition sip.h:375
sip_status_s::st_version
char const * st_version
Protocol version.
Definition sip.h:373
sip_status_s::st_status
int st_status
Status code.
Definition sip.h:374
sip_status_s::st_common
sip_common_t st_common[1]
Common fragment info.
Definition sip.h:371
sip_status_s::st_next
sip_error_t * st_next
Link to next (dummy).
Definition sip.h:372

## Function Documentation

## sip_is_status()

int sip_is_status | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_status_t.

Check if the header class is an instance of status line object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header status
  0 | (false) otherwise

## sip_status_copy()

sip_status_t * sip_status_copy | ( | su_home_t * | home,
|  | sip_status_t const * | hdr )

inline

Copy a list of status line header structures sip_status_t.

The function sip_status_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  status = sip_status_copy(home, sip->sip_status);
  sip_status_copy
  sip_status_t * sip_status_copy(su_home_t *home, sip_status_t const *hdr))
  Copy a list of status line header structures sip_status_t.
  Definition sip_protos.h:516

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_status_create()

sip_status_t * sip_status_create | ( | su_home_t * | home,
|  | unsigned | status,
|  | char const * | phrase,
|  | char const * | version )

Create a status line object.

Create a status line object.

Parameters

  home | memory home used to allocate sip_status_t object
  status | status code (in range 100 - 699)
  phrase | status phrase (may be NULL)
  version | version string (defaults to "SIP/2.0" if NULL)

Note
  If you provide an non-NULL version string, it is not copied. The string MUST remain constant.

Returns
  A pointer to newly created status line structure when successful, or NULL upon an error.

## sip_status_dup()

sip_status_t * sip_status_dup | ( | su_home_t * | home,
|  | sip_status_t const * | hdr )

inline

Duplicate a list of status line header structures sip_status_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  status = sip_status_dup(home, sip->sip_status);
  sip_status_dup
  sip_status_t * sip_status_dup(su_home_t *home, sip_status_t const *hdr))
  Duplicate a list of status line header structures sip_status_t.
  Definition sip_protos.h:473

Returns
  A pointer to the newly duplicated sip_status_t header structure, or NULL upon an error.

## sip_status_format()

sip_status_t * sip_status_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a status line from formatting result.

Make a new sip_status_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_status_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_status_init()

sip_status_t * sip_status_init | ( | sip_status_t | x[1] | ) |

inline

Initialize a structure sip_status_t.

An sip_status_t structure for status line can be initialized with the sip_status_init() function/macro. For instance,

sip_status_t sip_status;
sip_status_init(&sip_status);
sip_status_init
sip_status_t * sip_status_init(sip_status_t x[1])
Initialize a structure sip_status_t.
Definition sip_protos.h:404

## sip_status_make()

sip_status_t * sip_status_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a status line structure sip_status_t.

The function sip_status_make() makes a new sip_status_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_status_t header structure, or NULL upon an error.

## Variable Documentation

## sip_status_class

msg_hclass_t sip_status_class[]

extern

Header class for status line.

The header class sip_status_class defines how a SIP status line is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_status_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.